# AbcSimplex Class Reference

`#include <AbcSimplex.hpp>`

Inheritance diagram for AbcSimplex:
[legend]
Collaboration diagram for AbcSimplex:
[legend]

List of all members.

## Public Types
enum | Status { atLowerBound = 0x00, atUpperBound = 0x01, isFree = 0x04, superBasic = 0x05, basic = 0x06, isFixed = 0x07 }
| enums for status of various sorts. More...
enum | FakeBound { noFake = 0x00, lowerFake = 0x01, upperFake = 0x02, bothFake = 0x03 }
## Public Member Functions
void | defaultFactorizationFrequency ()
| If user left factorization frequency then compute.
Constructors and destructor and copy
| AbcSimplex (bool emptyMessages=false)
| Default constructor.
| AbcSimplex (const AbcSimplex &rhs)
| Copy constructor.
| AbcSimplex (const ClpSimplex &rhs)
| Copy constructor from model.
| AbcSimplex (const ClpSimplex *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor.
| AbcSimplex (const AbcSimplex *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor.
| AbcSimplex (AbcSimplex *wholeModel, int numberColumns, const int *whichColumns)
| This constructor modifies original AbcSimplex and stores original stuff in created AbcSimplex.
void | originalModel (AbcSimplex *miniModel)
| This copies back stuff from miniModel and then deletes miniModel.
| AbcSimplex (const ClpSimplex *clpSimplex)
| This constructor copies from ClpSimplex.
void | putBackSolution (ClpSimplex *simplex)
| Put back solution into ClpSimplex.
void | makeBaseModel ()
| Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.
void | deleteBaseModel ()
| Switch off base model.
AbcSimplex * | baseModel () const
| See if we have base model.
void | setToBaseModel (AbcSimplex *model=NULL)
| Reset to base model (just size and arrays needed) If model NULL use internal copy.
AbcSimplex & | operator= (const AbcSimplex &rhs)
| Assignment operator. This copies the data.
| ~AbcSimplex ()
| Destructor.
Functions most useful to user
int | dual ()
| Dual algorithm - see AbcSimplexDual.hpp for method.
int | doAbcDual ()
| Dual algorithm - see AbcSimplexDual.hpp for method.
int | primal (int ifValuesPass)
| Primal algorithm - see AbcSimplexPrimal.hpp for method.
int | doAbcPrimal (int ifValuesPass)
| Dual algorithm - see AbcSimplexDual.hpp for method.
CoinWarmStartBasis * | getBasis () const
| Returns a basis (to be deleted by user).
void | setFactorization (AbcSimplexFactorization &factorization)
| Passes in factorization.
AbcSimplexFactorization * | swapFactorization (AbcSimplexFactorization *factorization)
| Swaps factorization.
AbcSimplexFactorization * | getEmptyFactorization ()
| Gets clean and emptyish factorization.
int | tightenPrimalBounds ()
| Tightens primal bounds to make dual faster.
void | setDualRowPivotAlgorithm (AbcDualRowPivot &choice)
| Sets row pivot choice algorithm in dual.
void | setPrimalColumnPivotAlgorithm (AbcPrimalColumnPivot &choice)
| Sets column pivot choice algorithm in primal.
most useful gets and sets
AbcSimplexFactorization * | factorization () const
| factorization
int | factorizationFrequency () const
| Factorization frequency.
void | setFactorizationFrequency (int value)
| factorization
int | maximumAbcNumberRows () const
| Maximum rows.
int | maximumNumberTotal () const
| Maximum Total.
int | maximumTotal () const
| factorization
bool | isObjectiveLimitTestValid () const
| Return true if the objective limit test can be relied upon.
int | numberTotal () const
| Number of variables (includes spare rows).
int | numberTotalWithoutFixed () const
| Number of variables without fixed to zero (includes spare rows).
CoinPartitionedVector * | usefulArray (int index)
| Useful arrays (0,1,2,3,4,5,6,7).
CoinPartitionedVector * | usefulArray (int index) const
| factorization
double | clpObjectiveValue () const
| Objective value.
int * | pivotVariable () const
| Basic variables pivoting on which rows may be same as toExternal but may be as at invert.
int | stateOfProblem () const
| State of problem.
void | setStateOfProblem (int value)
| State of problem.
double * | scaleFromExternal () const
| Points from external to internal.
double * | scaleToExternal () const
| Scale from primal internal to external (in external order) Or other way for dual.
double * | rowScale2 () const
| corresponds to rowScale etc
double * | inverseRowScale2 () const
| factorization
double * | inverseColumnScale2 () const
| factorization
double * | columnScale2 () const
| factorization
int | arrayForDualColumn () const
| factorization
double | upperTheta () const
| upper theta from dual column
int | arrayForReplaceColumn () const
| factorization
int | arrayForFlipBounds () const
| factorization
int | arrayForFlipRhs () const
| factorization
int | arrayForBtran () const
| factorization
int | arrayForFtran () const
| factorization
int | arrayForTableauRow () const
| factorization
double | valueIncomingDual () const
| value of incoming variable (in Dual)
const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
Functions less likely to be useful to casual user
int | getSolution ()
| Given an existing factorization computes and checks primal and dual solutions.
void | setClpSimplexObjectiveValue ()
| Sets objectiveValue_ from rawObjectiveValue_.
void | setupDualValuesPass (const double *fakeDuals, const double *fakePrimals, int type)
| Sets dual values pass djs using unscaled duals type 1 - values pass type 2 - just use as infeasibility weights type 3 - as 2 but crash.
double | minimizationObjectiveValue () const
| Gets objective value with all offsets but as for minimization.
double | currentDualTolerance () const
| Current dualTolerance (will end up as dualTolerance_).
void | setCurrentDualTolerance (double value)
| Given an existing factorization computes and checks primal and dual solutions.
AbcNonLinearCost * | abcNonLinearCost () const
| Return pointer to details of costs.
double * | perturbationSaved () const
| Perturbation (fixed) - is just scaled random numbers.
double | acceptablePivot () const
| Acceptable pivot for this iteration.
int | ordinaryVariables () const
| Set to 1 if no free or super basic.
int | numberOrdinary () const
| Number of ordinary (lo/up) in tableau row.
void | setNumberOrdinary (int number)
| Set number of ordinary (lo/up) in tableau row.
double | currentDualBound () const
| Current dualBound (will end up as dualBound_).
AbcDualRowPivot * | dualRowPivot () const
| dual row pivot choice
AbcPrimalColumnPivot * | primalColumnPivot () const
| primal column pivot choice
AbcMatrix * | abcMatrix () const
| Abc Matrix.
int | internalFactorize (int solveType)
| Factorizes using current basis.
void | permuteIn ()
| Permutes in from ClpModel data - assumes scale factors done and AbcMatrix exists but is in original order (including slacks) For now just add basicArray at end == But could partition into normal (i.e.
void | permuteBasis ()
| deals with new basis and puts in abcPivotVariable_
void | permuteOut (int whatsWanted)
| Permutes out - bit settings same as stateOfProblem.
ClpDataSave | saveData ()
| Save data.
void | restoreData (ClpDataSave saved)
| Restore data.
void | cleanStatus (bool valuesPass=false)
| Clean up status - make sure no superbasic etc.
int | computeDuals (double *givenDjs, CoinIndexedVector *array1, CoinIndexedVector *array2)
| Computes duals from scratch.
int | computePrimals (CoinIndexedVector *array1, CoinIndexedVector *array2)
| Computes primals from scratch. Returns number of refinements.
void | computeObjective ()
| Computes nonbasic cost and total cost.
void | setMultipleSequenceIn (int sequenceIn[4])
| set multiple sequence in
void | unpack (CoinIndexedVector &rowArray) const
| Unpacks one column of the matrix into indexed array Uses sequenceIn_.
void | unpack (CoinIndexedVector &rowArray, int sequence) const
| Unpacks one column of the matrix into indexed array.
int | housekeeping ()
| This does basis housekeeping and does values for in/out variables.
void | checkPrimalSolution (bool justBasic)
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal).
void | checkDualSolution ()
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual).
void | checkDualSolutionPlusFake ()
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities AND sumFakeInfeasibilites_ (Dual).
void | checkBothSolutions ()
| This sets sum and number of infeasibilities (Dual and Primal).
int | gutsOfSolution (int type)
| Computes solutions - 1 do duals, 2 do primals, 3 both (returns number of refinements).
int | gutsOfPrimalSolution (int type)
| Computes solutions - 1 do duals, 2 do primals, 3 both (returns number of refinements).
void | saveGoodStatus ()
| Saves good status etc.
void | restoreGoodStatus (int type)
| Restores previous good status and says trouble.
void | refreshCosts ()
| After modifying first copy refreshes second copy and marks as updated.
void | refreshLower (unsigned int type=~(ROW_LOWER_SAME|COLUMN_UPPER_SAME))
| Given an existing factorization computes and checks primal and dual solutions.
void | refreshUpper (unsigned int type=~(ROW_LOWER_SAME|COLUMN_LOWER_SAME))
| Given an existing factorization computes and checks primal and dual solutions.
void | setupPointers (int maxRows, int maxColumns)
| Sets up all extra pointers.
void | copyFromSaved (int type=31)
| Copies all saved versions to working versions and may do something for perturbation.
void | fillPerturbation (int start, int number)
| fills in perturbationSaved_ from start with 0.5+random
void | checkArrays (int ignoreEmpty=0) const
| For debug - prints summary of arrays which are out of kilter.
void | checkDjs (int type=1) const
| For debug - summarizes dj situation (1 recomputes duals first, 2 checks duals as well).
void | checkSolutionBasic () const
| For debug - checks solutionBasic.
void | checkMoveBack (bool checkDuals)
| For debug - moves solution back to external and computes stuff (always checks djs).
void | setValuesPassAction (double incomingInfeasibility, double allowedInfeasibility)
| For advanced use.
int | cleanFactorization (int ifValuesPass)
| Get a clean factorization - i.e.
void | moveStatusToClp (ClpSimplex *clpModel)
| Move status and solution to ClpSimplex.
void | moveStatusFromClp (ClpSimplex *clpModel)
| Move status and solution from ClpSimplex.
protected methods
int | gutsOfSolution (double *givenDuals, const double *givenPrimals, bool valuesPass=false)
| May change basis and then returns number changed.
void | gutsOfDelete (int type)
| Does most of deletion for arrays etc(0 just null arrays, 1 delete first).
void | gutsOfCopy (const AbcSimplex &rhs)
| Does most of copying.
void | gutsOfInitialize (int numberRows, int numberColumns, bool doMore)
| Initializes arrays.
void | gutsOfResize (int numberRows, int numberColumns)
| resizes arrays
void | translate (int type)
| Translates ClpModel to AbcSimplex See DO_ bits in stateOfProblem_ for type e.g.
void | moveToBasic (int which=15)
| Moves basic stuff to basic area.
public methods
double * | solutionRegion () const
| Return region.
double * | djRegion () const
| Return region.
double * | lowerRegion () const
| Return region.
double * | upperRegion () const
| Return region.
double * | costRegion () const
| Return region.
double * | solutionRegion (int which) const
| Return region.
double * | djRegion (int which) const
| Return region.
double * | lowerRegion (int which) const
| Return region.
double * | upperRegion (int which) const
| Return region.
double * | costRegion (int which) const
| Return region.
double * | solutionBasic () const
| Return region.
double * | djBasic () const
| Return region.
double * | lowerBasic () const
| Return region.
double * | upperBasic () const
| Return region.
double * | costBasic () const
| Return region.
double * | abcPerturbation () const
| Perturbation.
double * | fakeDjs () const
| Fake djs.
unsigned char * | internalStatus () const
| Return region.
AbcSimplex::Status | getInternalStatus (int sequence) const
| Return region.
AbcSimplex::Status | getInternalColumnStatus (int sequence) const
| Return region.
void | setInternalStatus (int sequence, AbcSimplex::Status newstatus)
| Return region.
void | setInternalColumnStatus (int sequence, AbcSimplex::Status newstatus)
| Return region.
void | setInitialDenseFactorization (bool onOff)
| Normally the first factorization does sparse coding because the factorization could be singular.
bool | initialDenseFactorization () const
| Return region.
int | sequenceIn () const
| Return sequence In or Out.
int | sequenceOut () const
| Return region.
void | setSequenceIn (int sequence)
| Set sequenceIn or Out.
void | setSequenceOut (int sequence)
| Return region.
int | isColumn (int sequence) const
| Returns 1 if sequence indicates column.
int | sequenceWithin (int sequence) const
| Returns sequence number within section.
int | lastPivotRow () const
| Current/last pivot row (set after END of choosing pivot row in dual).
int | firstFree () const
| First Free_.
int | lastFirstFree () const
| Last firstFree_.
int | freeSequenceIn () const
| Free chosen vector.
double | currentAcceptablePivot () const
| Acceptable pivot for this iteration.
int | fakeSuperBasic (int iSequence)
| Returns 1 if fake superbasic 0 if free or true superbasic -1 if was fake but has cleaned itself up (sets status) -2 if wasn't fake.
double | solution (int sequence)
| Return row or column values.
double & | solutionAddress (int sequence)
| Return address of row or column values.
double | reducedCost (int sequence)
| Return region.
double & | reducedCostAddress (int sequence)
| Return region.
double | lower (int sequence)
| Return region.
double & | lowerAddress (int sequence)
| Return address of row or column lower bound.
double | upper (int sequence)
| Return region.
double & | upperAddress (int sequence)
| Return address of row or column upper bound.
double | cost (int sequence)
| Return region.
double & | costAddress (int sequence)
| Return address of row or column cost.
double | originalLower (int iSequence) const
| Return original lower bound.
double | originalUpper (int iSequence) const
| Return original lower bound.
AbcSimplexProgress * | abcProgress ()
| For dealing with all issues of cycling etc.
void | clearArraysPublic (int which)
| Clears an array and says available (-1 does all) when no possibility of going parallel.
int | getAvailableArrayPublic () const
| Returns first available empty array (and sets flag) when no possibility of going parallel.
void | clearArrays (int which)
| Clears an array and says available (-1 does all).
void | clearArrays (CoinPartitionedVector *which)
| Clears an array and says available.
int | getAvailableArray () const
| Returns first available empty array (and sets flag).
void | setUsedArray (int which) const
| Say array going to be used.
void | setAvailableArray (int which) const
| Say array going available.
void | swapPrimalStuff ()
| Swaps primal stuff.
void | swapDualStuff (int lastSequenceOut, int lastDirectionOut)
| Swaps dual stuff.
Changing bounds on variables and constraints
void | setObjectiveCoefficient (int elementIndex, double elementValue)
| Set an objective function coefficient.
void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
void | setColumnLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
void | setColumnUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
void | setColumnBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound.
void | setColumnSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
void | setColBounds (int elementIndex, double newlower, double newupper)
| Set a single column lower and upper bound.
void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously .
void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity.
void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity.
void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound.
void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously .
void | resize (int newNumberRows, int newNumberColumns)
| Resizes rim part of model.
## Friends
void | AbcSimplexUnitTest (const std::string &mpsDir)
| A function that tests the methods in the AbcSimplex class.
## data. Many arrays have a row part and a column part.
There is a single array with both - columns then rows and then normally two arrays pointing to rows and columns. The single array is the owner of memory
double | sumNonBasicCosts_
| Sum of nonbasic costs.
double | rawObjectiveValue_
| Sum of costs (raw objective value).
double | objectiveOffset_
| Objective offset (from offset_).
double | perturbationFactor_
| Perturbation factor If <0.0 then virtual if 0.0 none if >0.0 use this as factor.
double | currentDualTolerance_
| Current dualTolerance (will end up as dualTolerance_).
double | currentDualBound_
| Current dualBound (will end up as dualBound_).
double | largestGap_
| Largest gap.
double | lastDualBound_
| Last dual bound.
double | sumFakeInfeasibilities_
| Sum of infeasibilities when using fake perturbation tolerance.
double | lastPrimalError_
| Last primal error.
double | lastDualError_
| Last dual error.
double | currentAcceptablePivot_
| Acceptable pivot for this iteration.
double | movement_
| Movement of variable.
double | objectiveChange_
| Objective change.
double | btranAlpha_
| Btran alpha.
double | ftAlpha_
| FT alpha.
double | minimumThetaMovement_
| Minimum theta movement.
double | initialSumInfeasibilities_
| Initial sum of infeasibilities.
int | lastFirstFree_
| Last firstFree_.
int | freeSequenceIn_
| Free chosen vector.
int | maximumAbcNumberRows_
| Maximum number rows.
int | maximumAbcNumberColumns_
| Maximum number columns.
int | maximumNumberTotal_
| Maximum numberTotal.
int | numberFlagged_
| Current number of variables flagged.
int | normalDualColumnIteration_
| Iteration at which to do relaxed dualColumn.
int | stateDualColumn_
| State of dual waffle -2 - in initial large tolerance phase -1 - in medium tolerance phase n - in correct tolerance phase and thought optimal n times.
int | numberTotal_
| Number of variables (includes spare rows).
int | numberTotalWithoutFixed_
| Number of variables without fixed to zero (includes spare rows).
int | startAtLowerOther_
| Start of variables at lower bound with upper.
int | startAtUpperNoOther_
| Start of variables at upper bound with no lower.
int | startAtUpperOther_
| Start of variables at upper bound with lower.
int | startOther_
| Start of superBasic, free or awkward bounds variables.
int | startFixed_
| Start of fixed variables.
int | stateOfProblem_
| Sum of nonbasic costs.
int | numberOrdinary_
| Number of ordinary (lo/up) in tableau row.
int | ordinaryVariables_
| Set to 1 if no free or super basic.
int | numberFreeNonBasic_
| Number of free nonbasic variables.
int | lastCleaned_
| Last time cleaned up.
int | lastPivotRow_
| Current/last pivot row (set after END of choosing pivot row in dual).
int | swappedAlgorithm_
| Nonzero (probably 10) if swapped algorithms.
int | initialNumberInfeasibilities_
| Initial number of infeasibilities.
double * | scaleFromExternal_
| Points from external to internal.
double * | scaleToExternal_
| Scale from primal internal to external (in external order) Or other way for dual.
double * | columnUseScale_
| use this instead of columnScale
double * | inverseColumnUseScale_
| use this instead of inverseColumnScale
double * | offset_
| Primal offset (in external order) So internal value is (external-offset)*scaleFromExternal.
double * | offsetRhs_
| Offset for accumulated offsets*matrix.
double * | tempArray_
| Useful array of numberTotal length.
unsigned char * | internalStatus_
| Working status ? may be signed ? link pi_ to an indexed array? may have saved from last factorization at end.
unsigned char * | internalStatusSaved_
| Saved status.
double * | abcPerturbation_
| Perturbation (fixed) - is just scaled random numbers If perturbationFactor_<0 then virtual perturbation.
double * | perturbationSaved_
| saved perturbation
double * | perturbationBasic_
| basic perturbation
AbcMatrix * | abcMatrix_
| Working matrix.
double * | abcLower_
| Working scaled copy of lower bounds has original scaled copy at end.
double * | abcUpper_
| Working scaled copy of upper bounds has original scaled copy at end.
double * | abcCost_
| Working scaled copy of objective ? where perturbed copy or can we always work with perturbed copy (in B&B) if we adjust increments/cutoffs ? should we save a fixed perturbation offset array has original scaled copy at end.
double * | abcSolution_
| Working scaled primal solution may have saved from last factorization at end.
double * | abcDj_
| Working scaled dual solution may have saved from last factorization at end.
double * | lowerSaved_
| Saved scaled copy of lower bounds.
double * | upperSaved_
| Saved scaled copy of upper bounds.
double * | costSaved_
| Saved scaled copy of objective.
double * | solutionSaved_
| Saved scaled primal solution.
double * | djSaved_
| Saved scaled dual solution.
double * | lowerBasic_
| Working scaled copy of basic lower bounds.
double * | upperBasic_
| Working scaled copy of basic upper bounds.
double * | costBasic_
| Working scaled copy of basic objective.
double * | solutionBasic_
| Working scaled basic primal solution.
double * | djBasic_
| Working scaled basic dual solution (want it to be zero).
AbcDualRowPivot * | abcDualRowPivot_
| dual row pivot choice
AbcPrimalColumnPivot * | abcPrimalColumnPivot_
| primal column pivot choice
int * | abcPivotVariable_
| Basic variables pivoting on which rows followed by atLo/atUp then free/superbasic then fixed.
int * | reversePivotVariable_
| Reverse abcPivotVariable_ for moving around.
AbcSimplexFactorization * | abcFactorization_
| factorization
AbcSimplex * | abcBaseModel_
| Saved version of solution.
ClpSimplex * | clpModel_
| A copy of model as ClpSimplex with certain state.
AbcNonLinearCost * | abcNonLinearCost_
| Very wasteful way of dealing with infeasibilities in primal.
CoinPartitionedVector | usefulArray_ [ABC_NUMBER_USEFUL]
| Sum of nonbasic costs.
AbcSimplexProgress | abcProgress_
| For dealing with all issues of cycling etc.
ClpDataSave | saveData_
| For saving stuff at beginning.
double | upperTheta_
| upper theta from dual column
int | multipleSequenceIn_ [4]
| Multiple sequence in.
int | numberFlipped_
| Sum of nonbasic costs.
int | numberDisasters_
| Sum of nonbasic costs.
int | stateOfIteration_
| Where we are in iteration.
int | arrayForDualColumn_
| Sum of nonbasic costs.
int | arrayForReplaceColumn_
| Sum of nonbasic costs.
int | arrayForFlipBounds_
| Sum of nonbasic costs.
int | arrayForFlipRhs_
| Sum of nonbasic costs.
int | arrayForBtran_
| Sum of nonbasic costs.
int | arrayForFtran_
| Sum of nonbasic costs.
int | arrayForTableauRow_
| Sum of nonbasic costs.
## status methods
void | swap (int pivotRow, int nonBasicPosition)
| Swaps two variables.
void | setFlagged (int sequence)
| To flag a variable.
void | clearFlagged (int sequence)
| Swaps two variables.
bool | flagged (int sequence) const
| Swaps two variables.
void | createStatus ()
| Set up status array (can be used by OsiAbc).
void | crash (int type)
| Does sort of crash.
void | putStuffInBasis (int type)
| Puts more stuff in basis 1 bit set - do even if basis exists 2 bit set - don't bother staying triangular.
void | allSlackBasis ()
| Sets up all slack basis and resets solution to as it was after initial load or readMps.
void | checkConsistentPivots () const
| For debug - check pivotVariable consistent.
void | printStuff () const
| Print stuff.
int | startup (int ifValuesPass)
| Common bits of coding for dual and primal.
double | rawObjectiveValue () const
| Raw objective value (so always minimize in primal).
void | computeObjectiveValue (bool useWorkingSolution=false)
| Compute objective value from solution and put in objectiveValue_.
double | computeInternalObjectiveValue ()
| Compute minimization objective value from internal solution without perturbation.
void | moveInfo (const AbcSimplex &rhs, bool justStatus=false)
| Move status and solution across.
void | swap (int pivotRow, int nonBasicPosition, Status newStatus)
| Swaps two variables and does status.
void | setFakeBound (int sequence, FakeBound fakeBound)
| Swaps two variables.
FakeBound | getFakeBound (int sequence) const
| Swaps two variables.
bool | atFakeBound (int sequence) const
| Swaps two variables.
void | setPivoted (int sequence)
| Swaps two variables.
void | clearPivoted (int sequence)
| Swaps two variables.
bool | pivoted (int sequence) const
| Swaps two variables.
void | setActive (int iRow)
| To say row active in primal pivot row choice.
void | clearActive (int iRow)
| Swaps two variables.
bool | active (int iRow) const
| Swaps two variables.

## Detailed Description

Definition at line 62 of file AbcSimplex.hpp.

## Member Enumeration Documentation

enum AbcSimplex::Status

enums for status of various sorts.

ClpModel order (and warmstart) is isFree = 0x00, basic = 0x01, atUpperBound = 0x02, atLowerBound = 0x03, isFixed means fixed at lower bound and out of basis

Enumerator:

  atLowerBound |
  atUpperBound |
  isFree |
  superBasic |
  basic |
  isFixed |

Reimplemented from ClpSimplex.

Definition at line 74 of file AbcSimplex.hpp.

enum AbcSimplex::FakeBound

Enumerator:

  noFake |
  lowerFake |
  upperFake |
  bothFake |

Reimplemented from ClpSimplex.

Definition at line 83 of file AbcSimplex.hpp.

## Constructor & Destructor Documentation

AbcSimplex::AbcSimplex | ( | bool | emptyMessages = `false` | ) |

Default constructor.

AbcSimplex::AbcSimplex | ( | const AbcSimplex & | rhs | ) |

Copy constructor.

AbcSimplex::AbcSimplex | ( | const ClpSimplex & | rhs | ) |

Copy constructor from model.

AbcSimplex::AbcSimplex | ( | const ClpSimplex * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false` |
| ) |  |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

AbcSimplex::AbcSimplex | ( | const AbcSimplex * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false` |
| ) |  |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

AbcSimplex::AbcSimplex | ( | AbcSimplex * | wholeModel,
|  | int | numberColumns,
|  | const int * | whichColumns |
| ) |  |  |

This constructor modifies original AbcSimplex and stores original stuff in created AbcSimplex.

It is only to be used in conjunction with originalModel

AbcSimplex::AbcSimplex | ( | const ClpSimplex * | clpSimplex | ) |

This constructor copies from ClpSimplex.

AbcSimplex::~AbcSimplex | ( |  | ) |

Destructor.

## Member Function Documentation

void AbcSimplex::originalModel | ( | AbcSimplex * | miniModel | ) |

This copies back stuff from miniModel and then deletes miniModel.

Only to be used with mini constructor

Reimplemented from ClpSimplex.

void AbcSimplex::putBackSolution | ( | ClpSimplex * | simplex | ) |

Put back solution into ClpSimplex.

void AbcSimplex::makeBaseModel | ( |  | ) |

Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.

Save a copy of model with certain state - normally without cuts

Reimplemented from ClpSimplex.

void AbcSimplex::deleteBaseModel | ( |  | ) |

Switch off base model.

Reimplemented from ClpSimplex.

AbcSimplex* AbcSimplex::baseModel | ( |  | ) | const`[inline]`

See if we have base model.

Reimplemented from ClpSimplex.

Definition at line 146 of file AbcSimplex.hpp.

void AbcSimplex::setToBaseModel | ( | AbcSimplex * | model = `NULL` | ) |

Reset to base model (just size and arrays needed) If model NULL use internal copy.

Reimplemented from ClpSimplex.

AbcSimplex& AbcSimplex::operator= | ( | const AbcSimplex & | rhs | ) |

Assignment operator. This copies the data.

Reimplemented from ClpSimplex.

int AbcSimplex::dual | ( |  | ) |

Dual algorithm - see AbcSimplexDual.hpp for method.

Reimplemented in AbcSimplexDual.

int AbcSimplex::doAbcDual | ( |  | ) |

Dual algorithm - see AbcSimplexDual.hpp for method.

int AbcSimplex::primal | ( | int | ifValuesPass | ) |

Primal algorithm - see AbcSimplexPrimal.hpp for method.

int AbcSimplex::doAbcPrimal | ( | int | ifValuesPass | ) |

Dual algorithm - see AbcSimplexDual.hpp for method.

CoinWarmStartBasis* AbcSimplex::getBasis | ( |  | ) | const

Returns a basis (to be deleted by user).

Reimplemented from ClpSimplex.

void AbcSimplex::setFactorization | ( | AbcSimplexFactorization & | factorization | ) |

Passes in factorization.

AbcSimplexFactorization* AbcSimplex::swapFactorization | ( | AbcSimplexFactorization * | factorization | ) |

Swaps factorization.

AbcSimplexFactorization* AbcSimplex::getEmptyFactorization | ( |  | ) |

Gets clean and emptyish factorization.

Reimplemented from ClpSimplex.

int AbcSimplex::tightenPrimalBounds | ( |  | ) |

Tightens primal bounds to make dual faster.

Unless fixed or doTight>10, bounds are slightly looser than they could be. This is to make dual go faster and is probably not needed with a presolve. Returns non-zero if problem infeasible.

Fudge for branch and bound - put bounds on columns of factor * largest value (at continuous) - should improve stability in branch and bound on infeasible branches (0.0 is off)

void AbcSimplex::setDualRowPivotAlgorithm | ( | AbcDualRowPivot & | choice | ) |

Sets row pivot choice algorithm in dual.

void AbcSimplex::setPrimalColumnPivotAlgorithm | ( | AbcPrimalColumnPivot & | choice | ) |

Sets column pivot choice algorithm in primal.

void AbcSimplex::defaultFactorizationFrequency | ( |  | ) |

If user left factorization frequency then compute.

Reimplemented from ClpSimplex.

AbcSimplexFactorization* AbcSimplex::factorization | ( |  | ) | const`[inline]`

factorization

Reimplemented from ClpSimplex.

Definition at line 199 of file AbcSimplex.hpp.

int AbcSimplex::factorizationFrequency | ( |  | ) | const

Factorization frequency.

Reimplemented from ClpSimplex.

void AbcSimplex::setFactorizationFrequency | ( | int | value | ) |

factorization

Reimplemented from ClpSimplex.

int AbcSimplex::maximumAbcNumberRows | ( |  | ) | const`[inline]`

Maximum rows.

Definition at line 212 of file AbcSimplex.hpp.

int AbcSimplex::maximumNumberTotal | ( |  | ) | const`[inline]`

Maximum Total.

Definition at line 215 of file AbcSimplex.hpp.

int AbcSimplex::maximumTotal | ( |  | ) | const`[inline]`

factorization

Definition at line 217 of file AbcSimplex.hpp.

bool AbcSimplex::isObjectiveLimitTestValid | ( |  | ) | const

Return true if the objective limit test can be relied upon.

Reimplemented from ClpSimplex.

int AbcSimplex::numberTotal | ( |  | ) | const`[inline]`

Number of variables (includes spare rows).

Definition at line 222 of file AbcSimplex.hpp.

int AbcSimplex::numberTotalWithoutFixed | ( |  | ) | const`[inline]`

Number of variables without fixed to zero (includes spare rows).

Definition at line 225 of file AbcSimplex.hpp.

CoinPartitionedVector* AbcSimplex::usefulArray | ( | int | index | ) | `[inline]`

Useful arrays (0,1,2,3,4,5,6,7).

Definition at line 228 of file AbcSimplex.hpp.

CoinPartitionedVector* AbcSimplex::usefulArray | ( | int | index | ) | const`[inline]`

factorization

Definition at line 231 of file AbcSimplex.hpp.

int AbcSimplex::getSolution | ( |  | ) |

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

Reimplemented from ClpSimplex.

void AbcSimplex::setClpSimplexObjectiveValue | ( |  | ) |

Sets objectiveValue_ from rawObjectiveValue_.

void AbcSimplex::setupDualValuesPass | ( | const double * | fakeDuals,
|  | const double * | fakePrimals,
|  | int | type |
| ) |  |  |

Sets dual values pass djs using unscaled duals type 1 - values pass type 2 - just use as infeasibility weights type 3 - as 2 but crash.

double AbcSimplex::minimizationObjectiveValue | ( |  | ) | const`[inline]`

Gets objective value with all offsets but as for minimization.

Definition at line 254 of file AbcSimplex.hpp.

double AbcSimplex::currentDualTolerance | ( |  | ) | const`[inline]`

Current dualTolerance (will end up as dualTolerance_).

Reimplemented from ClpSimplex.

Definition at line 257 of file AbcSimplex.hpp.

void AbcSimplex::setCurrentDualTolerance | ( | double | value | ) | `[inline]`

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

Reimplemented from ClpSimplex.

Definition at line 259 of file AbcSimplex.hpp.

AbcNonLinearCost* AbcSimplex::abcNonLinearCost | ( |  | ) | const`[inline]`

Return pointer to details of costs.

Definition at line 263 of file AbcSimplex.hpp.

double* AbcSimplex::perturbationSaved | ( |  | ) | const`[inline]`

Perturbation (fixed) - is just scaled random numbers.

Definition at line 267 of file AbcSimplex.hpp.

double AbcSimplex::acceptablePivot | ( |  | ) | const`[inline]`

Acceptable pivot for this iteration.

Definition at line 270 of file AbcSimplex.hpp.

int AbcSimplex::ordinaryVariables | ( |  | ) | const`[inline]`

Set to 1 if no free or super basic.

Definition at line 273 of file AbcSimplex.hpp.

int AbcSimplex::numberOrdinary | ( |  | ) | const`[inline]`

Number of ordinary (lo/up) in tableau row.

Definition at line 276 of file AbcSimplex.hpp.

void AbcSimplex::setNumberOrdinary | ( | int | number | ) | `[inline]`

Set number of ordinary (lo/up) in tableau row.

Definition at line 279 of file AbcSimplex.hpp.

double AbcSimplex::currentDualBound | ( |  | ) | const`[inline]`

Current dualBound (will end up as dualBound_).

Definition at line 282 of file AbcSimplex.hpp.

AbcDualRowPivot* AbcSimplex::dualRowPivot | ( |  | ) | const`[inline]`

dual row pivot choice

Reimplemented from ClpSimplex.

Definition at line 285 of file AbcSimplex.hpp.

AbcPrimalColumnPivot* AbcSimplex::primalColumnPivot | ( |  | ) | const`[inline]`

primal column pivot choice

Reimplemented from ClpSimplex.

Definition at line 289 of file AbcSimplex.hpp.

AbcMatrix* AbcSimplex::abcMatrix | ( |  | ) | const`[inline]`

Abc Matrix.

Definition at line 293 of file AbcSimplex.hpp.

int AbcSimplex::internalFactorize | ( | int | solveType | ) |

Factorizes using current basis.

solveType - 1 iterating, 0 initial, -1 external If 10 added then in primal values pass Return codes are as from AbcSimplexFactorization unless initial factorization when total number of singularities is returned. Special case is numberRows_+1 -> all slack basis. if initial should be before permute in pivotVariable may be same as toExternal

Reimplemented from ClpSimplex.

void AbcSimplex::permuteIn | ( |  | ) |

Permutes in from ClpModel data - assumes scale factors done and AbcMatrix exists but is in original order (including slacks) For now just add basicArray at end == But could partition into normal (i.e.

reasonable lower/upper) abnormal - free, odd bounds fixed == sets a valid pivotVariable Slacks always shifted by offset Fixed variables always shifted by offset Recode to allow row objective so can use pi from idiot etc

void AbcSimplex::permuteBasis | ( |  | ) |

deals with new basis and puts in abcPivotVariable_

void AbcSimplex::permuteOut | ( | int | whatsWanted | ) |

Permutes out - bit settings same as stateOfProblem.

ClpDataSave AbcSimplex::saveData | ( |  | ) |

Save data.

Reimplemented from ClpSimplex.

void AbcSimplex::restoreData | ( | ClpDataSave | saved | ) |

Restore data.

Reimplemented from ClpSimplex.

void AbcSimplex::cleanStatus | ( | bool | valuesPass = `false` | ) |

Clean up status - make sure no superbasic etc.

int AbcSimplex::computeDuals | ( | double * | givenDjs,
|  | CoinIndexedVector * | array1,
|  | CoinIndexedVector * | array2 |
| ) |  |  |

Computes duals from scratch.

If givenDjs then allows for nonzero basic djs. Returns number of refinements

int AbcSimplex::computePrimals | ( | CoinIndexedVector * | array1,
|  | CoinIndexedVector * | array2 |
| ) |  |  |

Computes primals from scratch. Returns number of refinements.

void AbcSimplex::computeObjective | ( |  | ) |

Computes nonbasic cost and total cost.

void AbcSimplex::setMultipleSequenceIn | ( | int | sequenceIn[4] | ) |

set multiple sequence in

void AbcSimplex::unpack | ( | CoinIndexedVector & | rowArray | ) | const`[inline]`

Unpacks one column of the matrix into indexed array Uses sequenceIn_.

Definition at line 345 of file AbcSimplex.hpp.

void AbcSimplex::unpack | ( | CoinIndexedVector & | rowArray,
|  | int | sequence |
| ) |  |  | const

Unpacks one column of the matrix into indexed array.

int AbcSimplex::housekeeping | ( |  | ) |

This does basis housekeeping and does values for in/out variables.

Can also decide to re-factorize

void AbcSimplex::checkPrimalSolution | ( | bool | justBasic | ) |

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal).

void AbcSimplex::checkDualSolution | ( |  | ) |

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual).

Reimplemented from ClpSimplex.

void AbcSimplex::checkDualSolutionPlusFake | ( |  | ) |

This sets largest infeasibility and most infeasible and sum and number of infeasibilities AND sumFakeInfeasibilites_ (Dual).

void AbcSimplex::checkBothSolutions | ( |  | ) |

This sets sum and number of infeasibilities (Dual and Primal).

Reimplemented from ClpSimplex.

int AbcSimplex::gutsOfSolution | ( | int | type | ) |

Computes solutions - 1 do duals, 2 do primals, 3 both (returns number of refinements).

int AbcSimplex::gutsOfPrimalSolution | ( | int | type | ) |

Computes solutions - 1 do duals, 2 do primals, 3 both (returns number of refinements).

void AbcSimplex::saveGoodStatus | ( |  | ) |

Saves good status etc.

void AbcSimplex::restoreGoodStatus | ( | int | type | ) |

Restores previous good status and says trouble.

void AbcSimplex::refreshCosts | ( |  | ) |

After modifying first copy refreshes second copy and marks as updated.

void AbcSimplex::refreshLower | ( | unsigned int | type = `~(ROW_LOWER_SAME|COLUMN_UPPER_SAME)` | ) |

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

void AbcSimplex::refreshUpper | ( | unsigned int | type = `~(ROW_LOWER_SAME|COLUMN_LOWER_SAME)` | ) |

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

void AbcSimplex::setupPointers | ( | int | maxRows,
|  | int | maxColumns |
| ) |  |  |

Sets up all extra pointers.

void AbcSimplex::copyFromSaved | ( | int | type = `31` | ) |

Copies all saved versions to working versions and may do something for perturbation.

void AbcSimplex::fillPerturbation | ( | int | start,
|  | int | number |
| ) |  |  |

fills in perturbationSaved_ from start with 0.5+random

void AbcSimplex::checkArrays | ( | int | ignoreEmpty = `0` | ) | const

For debug - prints summary of arrays which are out of kilter.

void AbcSimplex::checkDjs | ( | int | type = `1` | ) | const

For debug - summarizes dj situation (1 recomputes duals first, 2 checks duals as well).

void AbcSimplex::checkSolutionBasic | ( |  | ) | const

For debug - checks solutionBasic.

void AbcSimplex::checkMoveBack | ( | bool | checkDuals | ) |

For debug - moves solution back to external and computes stuff (always checks djs).

void AbcSimplex::setValuesPassAction | ( | double | incomingInfeasibility,
|  | double | allowedInfeasibility |
| ) |  |  |

For advanced use.

When doing iterative solves things can get nasty so on values pass if incoming solution has largest infeasibility < incomingInfeasibility throw out variables from basis until largest infeasibility < allowedInfeasibility or incoming largest infeasibility. If allowedInfeasibility>= incomingInfeasibility this is always possible altough you may end up with an all slack basis.

Defaults are 1.0,10.0

Reimplemented from ClpSimplex.

int AbcSimplex::cleanFactorization | ( | int | ifValuesPass | ) |

Get a clean factorization - i.e.

throw out singularities may do more later

Reimplemented from ClpSimplex.

void AbcSimplex::moveStatusToClp | ( | ClpSimplex * | clpModel | ) |

Move status and solution to ClpSimplex.

void AbcSimplex::moveStatusFromClp | ( | ClpSimplex * | clpModel | ) |

Move status and solution from ClpSimplex.

double AbcSimplex::clpObjectiveValue | ( |  | ) | const`[inline]`

Objective value.

Definition at line 421 of file AbcSimplex.hpp.

int* AbcSimplex::pivotVariable | ( |  | ) | const`[inline]`

Basic variables pivoting on which rows may be same as toExternal but may be as at invert.

Reimplemented from ClpSimplex.

Definition at line 426 of file AbcSimplex.hpp.

int AbcSimplex::stateOfProblem | ( |  | ) | const`[inline]`

State of problem.

Definition at line 430 of file AbcSimplex.hpp.

void AbcSimplex::setStateOfProblem | ( | int | value | ) | `[inline]`

State of problem.

Definition at line 433 of file AbcSimplex.hpp.

double* AbcSimplex::scaleFromExternal | ( |  | ) | const`[inline]`

Points from external to internal.

Points from internal to external Scale from primal external to internal (in external order) Or other way for dual

Definition at line 443 of file AbcSimplex.hpp.

double* AbcSimplex::scaleToExternal | ( |  | ) | const`[inline]`

Scale from primal internal to external (in external order) Or other way for dual.

Definition at line 447 of file AbcSimplex.hpp.

double* AbcSimplex::rowScale2 | ( |  | ) | const`[inline]`

corresponds to rowScale etc

Definition at line 450 of file AbcSimplex.hpp.

double* AbcSimplex::inverseRowScale2 | ( |  | ) | const`[inline]`

factorization

Definition at line 452 of file AbcSimplex.hpp.

double* AbcSimplex::inverseColumnScale2 | ( |  | ) | const`[inline]`

factorization

Definition at line 454 of file AbcSimplex.hpp.

double* AbcSimplex::columnScale2 | ( |  | ) | const`[inline]`

factorization

Definition at line 456 of file AbcSimplex.hpp.

int AbcSimplex::arrayForDualColumn | ( |  | ) | const`[inline]`

factorization

Definition at line 458 of file AbcSimplex.hpp.

double AbcSimplex::upperTheta | ( |  | ) | const`[inline]`

upper theta from dual column

Definition at line 461 of file AbcSimplex.hpp.

int AbcSimplex::arrayForReplaceColumn | ( |  | ) | const`[inline]`

factorization

Definition at line 463 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFlipBounds | ( |  | ) | const`[inline]`

factorization

Definition at line 465 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFlipRhs | ( |  | ) | const`[inline]`

factorization

Definition at line 467 of file AbcSimplex.hpp.

int AbcSimplex::arrayForBtran | ( |  | ) | const`[inline]`

factorization

Definition at line 469 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFtran | ( |  | ) | const`[inline]`

factorization

Definition at line 471 of file AbcSimplex.hpp.

int AbcSimplex::arrayForTableauRow | ( |  | ) | const`[inline]`

factorization

Definition at line 473 of file AbcSimplex.hpp.

double AbcSimplex::valueIncomingDual | ( |  | ) | const

value of incoming variable (in Dual)

Reimplemented from ClpSimplex.

const double* AbcSimplex::getColSolution | ( |  | ) | const

Get pointer to array[getNumCols()] of primal solution vector.

Reimplemented from ClpModel.

const double* AbcSimplex::getRowPrice | ( |  | ) | const

Get pointer to array[getNumRows()] of dual prices.

Reimplemented from ClpModel.

const double* AbcSimplex::getReducedCost | ( |  | ) | const

Get a pointer to array[getNumCols()] of reduced costs.

Reimplemented from ClpModel.

const double* AbcSimplex::getRowActivity | ( |  | ) | const

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Reimplemented from ClpModel.

int AbcSimplex::gutsOfSolution | ( | double * | givenDuals,
|  | const double * | givenPrimals,
|  | bool | valuesPass = `false` |
| ) |  |  |

May change basis and then returns number changed.

Computation of solutions may be overriden by given pi and solution

Reimplemented from ClpSimplex.

void AbcSimplex::gutsOfDelete | ( | int | type | ) |

Does most of deletion for arrays etc(0 just null arrays, 1 delete first).

Reimplemented from ClpSimplex.

void AbcSimplex::gutsOfCopy | ( | const AbcSimplex & | rhs | ) |

Does most of copying.

Reimplemented from ClpSimplex.

void AbcSimplex::gutsOfInitialize | ( | int | numberRows,
|  | int | numberColumns,
|  | bool | doMore |
| ) |  |  |

Initializes arrays.

void AbcSimplex::gutsOfResize | ( | int | numberRows,
|  | int | numberColumns |
| ) |  |  |

resizes arrays

void AbcSimplex::translate | ( | int | type | ) |

Translates ClpModel to AbcSimplex See DO_ bits in stateOfProblem_ for type e.g.

DO_BASIS_AND_ORDER

void AbcSimplex::moveToBasic | ( | int | which = `15` | ) |

Moves basic stuff to basic area.

double* AbcSimplex::solutionRegion | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 518 of file AbcSimplex.hpp.

double* AbcSimplex::djRegion | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 521 of file AbcSimplex.hpp.

double* AbcSimplex::lowerRegion | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 524 of file AbcSimplex.hpp.

double* AbcSimplex::upperRegion | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 527 of file AbcSimplex.hpp.

double* AbcSimplex::costRegion | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 530 of file AbcSimplex.hpp.

double* AbcSimplex::solutionRegion | ( | int | which | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 534 of file AbcSimplex.hpp.

double* AbcSimplex::djRegion | ( | int | which | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 537 of file AbcSimplex.hpp.

double* AbcSimplex::lowerRegion | ( | int | which | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 540 of file AbcSimplex.hpp.

double* AbcSimplex::upperRegion | ( | int | which | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 543 of file AbcSimplex.hpp.

double* AbcSimplex::costRegion | ( | int | which | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 546 of file AbcSimplex.hpp.

double* AbcSimplex::solutionBasic | ( |  | ) | const`[inline]`

Return region.

Definition at line 550 of file AbcSimplex.hpp.

double* AbcSimplex::djBasic | ( |  | ) | const`[inline]`

Return region.

Definition at line 553 of file AbcSimplex.hpp.

double* AbcSimplex::lowerBasic | ( |  | ) | const`[inline]`

Return region.

Definition at line 556 of file AbcSimplex.hpp.

double* AbcSimplex::upperBasic | ( |  | ) | const`[inline]`

Return region.

Definition at line 559 of file AbcSimplex.hpp.

double* AbcSimplex::costBasic | ( |  | ) | const`[inline]`

Return region.

Definition at line 562 of file AbcSimplex.hpp.

double* AbcSimplex::abcPerturbation | ( |  | ) | const`[inline]`

Perturbation.

Definition at line 566 of file AbcSimplex.hpp.

double* AbcSimplex::fakeDjs | ( |  | ) | const`[inline]`

Fake djs.

Definition at line 569 of file AbcSimplex.hpp.

unsigned char* AbcSimplex::internalStatus | ( |  | ) | const`[inline]`

Return region.

Definition at line 571 of file AbcSimplex.hpp.

AbcSimplex::Status AbcSimplex::getInternalStatus | ( | int | sequence | ) | const`[inline]`

Return region.

Definition at line 573 of file AbcSimplex.hpp.

AbcSimplex::Status AbcSimplex::getInternalColumnStatus | ( | int | sequence | ) | const`[inline]`

Return region.

Definition at line 576 of file AbcSimplex.hpp.

void AbcSimplex::setInternalStatus | ( | int | sequence,
|  | AbcSimplex::Status | newstatus |
| ) |  |  | `[inline]`

Return region.

Definition at line 579 of file AbcSimplex.hpp.

void AbcSimplex::setInternalColumnStatus | ( | int | sequence,
|  | AbcSimplex::Status | newstatus |
| ) |  |  | `[inline]`

Return region.

Definition at line 584 of file AbcSimplex.hpp.

void AbcSimplex::setInitialDenseFactorization | ( | bool | onOff | ) |

Normally the first factorization does sparse coding because the factorization could be singular.

This allows initial dense factorization when it is known to be safe

Reimplemented from ClpSimplex.

bool AbcSimplex::initialDenseFactorization | ( |  | ) | const

Return region.

Reimplemented from ClpSimplex.

int AbcSimplex::sequenceIn | ( |  | ) | const`[inline]`

Return sequence In or Out.

Reimplemented from ClpSimplex.

Definition at line 596 of file AbcSimplex.hpp.

int AbcSimplex::sequenceOut | ( |  | ) | const`[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 599 of file AbcSimplex.hpp.

void AbcSimplex::setSequenceIn | ( | int | sequence | ) | `[inline]`

Set sequenceIn or Out.

Reimplemented from ClpSimplex.

Definition at line 603 of file AbcSimplex.hpp.

void AbcSimplex::setSequenceOut | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 606 of file AbcSimplex.hpp.

int AbcSimplex::isColumn | ( | int | sequence | ) | const`[inline]`

Returns 1 if sequence indicates column.

Reimplemented from ClpSimplex.

Definition at line 626 of file AbcSimplex.hpp.

int AbcSimplex::sequenceWithin | ( | int | sequence | ) | const`[inline]`

Returns sequence number within section.

Reimplemented from ClpSimplex.

Definition at line 630 of file AbcSimplex.hpp.

int AbcSimplex::lastPivotRow | ( |  | ) | const`[inline]`

Current/last pivot row (set after END of choosing pivot row in dual).

Definition at line 634 of file AbcSimplex.hpp.

int AbcSimplex::firstFree | ( |  | ) | const`[inline]`

First Free_.

Definition at line 637 of file AbcSimplex.hpp.

int AbcSimplex::lastFirstFree | ( |  | ) | const`[inline]`

Last firstFree_.

Definition at line 640 of file AbcSimplex.hpp.

int AbcSimplex::freeSequenceIn | ( |  | ) | const`[inline]`

Free chosen vector.

Definition at line 643 of file AbcSimplex.hpp.

double AbcSimplex::currentAcceptablePivot | ( |  | ) | const`[inline]`

Acceptable pivot for this iteration.

Definition at line 646 of file AbcSimplex.hpp.

int AbcSimplex::fakeSuperBasic | ( | int | iSequence | ) | `[inline]`

Returns 1 if fake superbasic 0 if free or true superbasic -1 if was fake but has cleaned itself up (sets status) -2 if wasn't fake.

Definition at line 655 of file AbcSimplex.hpp.

double AbcSimplex::solution | ( | int | sequence | ) | `[inline]`

Return row or column values.

Reimplemented from ClpSimplex.

Definition at line 687 of file AbcSimplex.hpp.

double& AbcSimplex::solutionAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column values.

Reimplemented from ClpSimplex.

Definition at line 691 of file AbcSimplex.hpp.

double AbcSimplex::reducedCost | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 694 of file AbcSimplex.hpp.

double& AbcSimplex::reducedCostAddress | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 697 of file AbcSimplex.hpp.

double AbcSimplex::lower | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 700 of file AbcSimplex.hpp.

double& AbcSimplex::lowerAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column lower bound.

Reimplemented from ClpSimplex.

Definition at line 704 of file AbcSimplex.hpp.

double AbcSimplex::upper | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 707 of file AbcSimplex.hpp.

double& AbcSimplex::upperAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column upper bound.

Reimplemented from ClpSimplex.

Definition at line 711 of file AbcSimplex.hpp.

double AbcSimplex::cost | ( | int | sequence | ) | `[inline]`

Return region.

Reimplemented from ClpSimplex.

Definition at line 714 of file AbcSimplex.hpp.

double& AbcSimplex::costAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column cost.

Reimplemented from ClpSimplex.

Definition at line 718 of file AbcSimplex.hpp.

double AbcSimplex::originalLower | ( | int | iSequence | ) | const`[inline]`

Return original lower bound.

Reimplemented from ClpSimplex.

Definition at line 722 of file AbcSimplex.hpp.

double AbcSimplex::originalUpper | ( | int | iSequence | ) | const`[inline]`

Return original lower bound.

Reimplemented from ClpSimplex.

Definition at line 728 of file AbcSimplex.hpp.

AbcSimplexProgress* AbcSimplex::abcProgress | ( |  | ) | `[inline]`

For dealing with all issues of cycling etc.

Definition at line 734 of file AbcSimplex.hpp.

void AbcSimplex::clearArraysPublic | ( | int | which | ) | `[inline]`

Clears an array and says available (-1 does all) when no possibility of going parallel.

Definition at line 745 of file AbcSimplex.hpp.

int AbcSimplex::getAvailableArrayPublic | ( |  | ) | const`[inline]`

Returns first available empty array (and sets flag) when no possibility of going parallel.

Definition at line 749 of file AbcSimplex.hpp.

void AbcSimplex::clearArrays | ( | int | which | ) |

Clears an array and says available (-1 does all).

void AbcSimplex::clearArrays | ( | CoinPartitionedVector * | which | ) |

Clears an array and says available.

int AbcSimplex::getAvailableArray | ( |  | ) | const

Returns first available empty array (and sets flag).

void AbcSimplex::setUsedArray | ( | int | which | ) | const`[inline]`

Say array going to be used.

Definition at line 775 of file AbcSimplex.hpp.

void AbcSimplex::setAvailableArray | ( | int | which | ) | const`[inline]`

Say array going available.

Definition at line 778 of file AbcSimplex.hpp.

void AbcSimplex::swapPrimalStuff | ( |  | ) |

Swaps primal stuff.

void AbcSimplex::swapDualStuff | ( | int | lastSequenceOut,
|  | int | lastDirectionOut |
| ) |  |  |

Swaps dual stuff.

void AbcSimplex::swap | ( | int | pivotRow,
|  | int | nonBasicPosition,
|  | Status | newStatus |
| ) |  |  | `[protected]`

Swaps two variables and does status.

void AbcSimplex::setFakeBound | ( | int | sequence,
|  | FakeBound | fakeBound |
| ) |  |  | `[inline, protected]`

Swaps two variables.

Definition at line 791 of file AbcSimplex.hpp.

FakeBound AbcSimplex::getFakeBound | ( | int | sequence | ) | const`[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 796 of file AbcSimplex.hpp.

bool AbcSimplex::atFakeBound | ( | int | sequence | ) | const`[protected]`

Swaps two variables.

void AbcSimplex::setPivoted | ( | int | sequence | ) | `[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 800 of file AbcSimplex.hpp.

void AbcSimplex::clearPivoted | ( | int | sequence | ) | `[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 803 of file AbcSimplex.hpp.

bool AbcSimplex::pivoted | ( | int | sequence | ) | const`[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 806 of file AbcSimplex.hpp.

void AbcSimplex::swap | ( | int | pivotRow,
|  | int | nonBasicPosition |
| ) |  |  |

Swaps two variables.

void AbcSimplex::setFlagged | ( | int | sequence | ) |

To flag a variable.

Reimplemented from ClpSimplex.

void AbcSimplex::clearFlagged | ( | int | sequence | ) | `[inline]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 814 of file AbcSimplex.hpp.

bool AbcSimplex::flagged | ( | int | sequence | ) | const`[inline]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 817 of file AbcSimplex.hpp.

void AbcSimplex::setActive | ( | int | iRow | ) | `[inline, protected]`

To say row active in primal pivot row choice.

Reimplemented from ClpSimplex.

Definition at line 822 of file AbcSimplex.hpp.

void AbcSimplex::clearActive | ( | int | iRow | ) | `[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 825 of file AbcSimplex.hpp.

bool AbcSimplex::active | ( | int | iRow | ) | const`[inline, protected]`

Swaps two variables.

Reimplemented from ClpSimplex.

Definition at line 828 of file AbcSimplex.hpp.

void AbcSimplex::createStatus | ( |  | ) |

Set up status array (can be used by OsiAbc).

Also can be used to set up all slack basis

Reimplemented from ClpSimplex.

void AbcSimplex::crash | ( | int | type | ) |

Does sort of crash.

void AbcSimplex::putStuffInBasis | ( | int | type | ) |

Puts more stuff in basis 1 bit set - do even if basis exists 2 bit set - don't bother staying triangular.

void AbcSimplex::allSlackBasis | ( |  | ) |

Sets up all slack basis and resets solution to as it was after initial load or readMps.

void AbcSimplex::checkConsistentPivots | ( |  | ) | const

For debug - check pivotVariable consistent.

void AbcSimplex::printStuff | ( |  | ) | const

Print stuff.

int AbcSimplex::startup | ( | int | ifValuesPass | ) |

Common bits of coding for dual and primal.

double AbcSimplex::rawObjectiveValue | ( |  | ) | const`[inline]`

Raw objective value (so always minimize in primal).

Reimplemented from ClpSimplex.

Definition at line 853 of file AbcSimplex.hpp.

void AbcSimplex::computeObjectiveValue | ( | bool | useWorkingSolution = `false` | ) |

Compute objective value from solution and put in objectiveValue_.

Reimplemented from ClpSimplex.

double AbcSimplex::computeInternalObjectiveValue | ( |  | ) |

Compute minimization objective value from internal solution without perturbation.

Reimplemented from ClpSimplex.

void AbcSimplex::moveInfo | ( | const AbcSimplex & | rhs,
|  | bool | justStatus = `false` |
| ) |  |  |

Move status and solution across.

Reimplemented from ClpSimplex.

void AbcSimplex::setObjectiveCoefficient | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set an objective function coefficient.

Reimplemented from ClpSimplex.

void AbcSimplex::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set an objective function coefficient.

Reimplemented from ClpSimplex.

Definition at line 891 of file AbcSimplex.hpp.

void AbcSimplex::setColumnLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single column lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpSimplex.

void AbcSimplex::setColumnUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single column upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpSimplex.

void AbcSimplex::setColumnBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  |

Set a single column lower and upper bound.

Reimplemented from ClpSimplex.

void AbcSimplex::setColumnSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  |

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from ClpSimplex.

void AbcSimplex::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set a single column lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpSimplex.

Definition at line 921 of file AbcSimplex.hpp.

void AbcSimplex::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set a single column upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpSimplex.

Definition at line 926 of file AbcSimplex.hpp.

void AbcSimplex::setColBounds | ( | int | elementIndex,
|  | double | newlower,
|  | double | newupper |
| ) |  |  | `[inline]`

Set a single column lower and upper bound.

Reimplemented from ClpSimplex.

Definition at line 931 of file AbcSimplex.hpp.

void AbcSimplex::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[inline]`

Set the bounds on a number of columns simultaneously
.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from ClpSimplex.

Definition at line 942 of file AbcSimplex.hpp.

void AbcSimplex::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single row lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpSimplex.

void AbcSimplex::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single row upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpSimplex.

void AbcSimplex::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  |

Set a single row lower and upper bound.

Reimplemented from ClpSimplex.

void AbcSimplex::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  |

Set the bounds on a number of rows simultaneously
.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from ClpSimplex.

void AbcSimplex::resize | ( | int | newNumberRows,
|  | int | newNumberColumns |
| ) |  |  |

Resizes rim part of model.

Reimplemented from ClpSimplex.

## Friends And Related Function Documentation

void AbcSimplexUnitTest | ( | const std::string & | mpsDir | ) | `[friend]`

A function that tests the methods in the AbcSimplex class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

It also does some testing of AbcSimplexFactorization class

## Member Data Documentation

double AbcSimplex::sumNonBasicCosts_`[protected]`

Sum of nonbasic costs.

Definition at line 984 of file AbcSimplex.hpp.

double AbcSimplex::rawObjectiveValue_`[protected]`

Sum of costs (raw objective value).

Definition at line 986 of file AbcSimplex.hpp.

double AbcSimplex::objectiveOffset_`[protected]`

Objective offset (from offset_).

Definition at line 988 of file AbcSimplex.hpp.

double AbcSimplex::perturbationFactor_`[protected]`

Perturbation factor If <0.0 then virtual if 0.0 none if >0.0 use this as factor.

Definition at line 993 of file AbcSimplex.hpp.

double AbcSimplex::currentDualTolerance_`[protected]`

Current dualTolerance (will end up as dualTolerance_).

Definition at line 995 of file AbcSimplex.hpp.

double AbcSimplex::currentDualBound_`[protected]`

Current dualBound (will end up as dualBound_).

Definition at line 997 of file AbcSimplex.hpp.

double AbcSimplex::largestGap_`[protected]`

Largest gap.

Definition at line 999 of file AbcSimplex.hpp.

double AbcSimplex::lastDualBound_`[protected]`

Last dual bound.

Definition at line 1001 of file AbcSimplex.hpp.

double AbcSimplex::sumFakeInfeasibilities_`[protected]`

Sum of infeasibilities when using fake perturbation tolerance.

Definition at line 1003 of file AbcSimplex.hpp.

double AbcSimplex::lastPrimalError_`[protected]`

Last primal error.

Definition at line 1005 of file AbcSimplex.hpp.

double AbcSimplex::lastDualError_`[protected]`

Last dual error.

Definition at line 1007 of file AbcSimplex.hpp.

double AbcSimplex::currentAcceptablePivot_`[protected]`

Acceptable pivot for this iteration.

Definition at line 1009 of file AbcSimplex.hpp.

double AbcSimplex::movement_`[protected]`

Movement of variable.

Definition at line 1011 of file AbcSimplex.hpp.

double AbcSimplex::objectiveChange_`[protected]`

Objective change.

Definition at line 1013 of file AbcSimplex.hpp.

double AbcSimplex::btranAlpha_`[protected]`

Btran alpha.

Definition at line 1015 of file AbcSimplex.hpp.

double AbcSimplex::ftAlpha_`[protected]`

FT alpha.

Definition at line 1020 of file AbcSimplex.hpp.

double AbcSimplex::minimumThetaMovement_`[protected]`

Minimum theta movement.

Definition at line 1022 of file AbcSimplex.hpp.

double AbcSimplex::initialSumInfeasibilities_`[protected]`

Initial sum of infeasibilities.

Definition at line 1024 of file AbcSimplex.hpp.

int AbcSimplex::stateOfIteration_

Where we are in iteration.

Definition at line 1027 of file AbcSimplex.hpp.

int AbcSimplex::lastFirstFree_`[protected]`

Last firstFree_.

Definition at line 1030 of file AbcSimplex.hpp.

int AbcSimplex::freeSequenceIn_`[protected]`

Free chosen vector.

Definition at line 1032 of file AbcSimplex.hpp.

int AbcSimplex::maximumAbcNumberRows_`[protected]`

Maximum number rows.

Definition at line 1034 of file AbcSimplex.hpp.

int AbcSimplex::maximumAbcNumberColumns_`[protected]`

Maximum number columns.

Definition at line 1036 of file AbcSimplex.hpp.

int AbcSimplex::maximumNumberTotal_`[protected]`

Maximum numberTotal.

Definition at line 1038 of file AbcSimplex.hpp.

int AbcSimplex::numberFlagged_`[protected]`

Current number of variables flagged.

Definition at line 1040 of file AbcSimplex.hpp.

int AbcSimplex::normalDualColumnIteration_`[protected]`

Iteration at which to do relaxed dualColumn.

Definition at line 1042 of file AbcSimplex.hpp.

int AbcSimplex::stateDualColumn_`[protected]`

State of dual waffle -2 - in initial large tolerance phase -1 - in medium tolerance phase n - in correct tolerance phase and thought optimal n times.

Definition at line 1048 of file AbcSimplex.hpp.

int AbcSimplex::numberTotal_`[protected]`

Number of variables (includes spare rows).

Definition at line 1055 of file AbcSimplex.hpp.

int AbcSimplex::numberTotalWithoutFixed_`[protected]`

Number of variables without fixed to zero (includes spare rows).

Definition at line 1057 of file AbcSimplex.hpp.

int AbcSimplex::startAtLowerOther_`[protected]`

Start of variables at lower bound with upper.

Definition at line 1061 of file AbcSimplex.hpp.

int AbcSimplex::startAtUpperNoOther_`[protected]`

Start of variables at upper bound with no lower.

Definition at line 1063 of file AbcSimplex.hpp.

int AbcSimplex::startAtUpperOther_`[protected]`

Start of variables at upper bound with lower.

Definition at line 1065 of file AbcSimplex.hpp.

int AbcSimplex::startOther_`[protected]`

Start of superBasic, free or awkward bounds variables.

Definition at line 1067 of file AbcSimplex.hpp.

int AbcSimplex::startFixed_`[protected]`

Start of fixed variables.

Definition at line 1069 of file AbcSimplex.hpp.

int AbcSimplex::stateOfProblem_`[mutable, protected]`

Sum of nonbasic costs.

Definition at line 1107 of file AbcSimplex.hpp.

int AbcSimplex::numberOrdinary_`[protected]`

Number of ordinary (lo/up) in tableau row.

Definition at line 1115 of file AbcSimplex.hpp.

int AbcSimplex::ordinaryVariables_`[protected]`

Set to 1 if no free or super basic.

Definition at line 1117 of file AbcSimplex.hpp.

int AbcSimplex::numberFreeNonBasic_`[protected]`

Number of free nonbasic variables.

Definition at line 1119 of file AbcSimplex.hpp.

int AbcSimplex::lastCleaned_`[protected]`

Last time cleaned up.

Definition at line 1121 of file AbcSimplex.hpp.

int AbcSimplex::lastPivotRow_`[protected]`

Current/last pivot row (set after END of choosing pivot row in dual).

Definition at line 1123 of file AbcSimplex.hpp.

int AbcSimplex::swappedAlgorithm_`[protected]`

Nonzero (probably 10) if swapped algorithms.

Definition at line 1125 of file AbcSimplex.hpp.

int AbcSimplex::initialNumberInfeasibilities_`[protected]`

Initial number of infeasibilities.

Definition at line 1127 of file AbcSimplex.hpp.

double* AbcSimplex::scaleFromExternal_`[protected]`

Points from external to internal.

Points from internal to external Scale from primal external to internal (in external order) Or other way for dual

Definition at line 1134 of file AbcSimplex.hpp.

double* AbcSimplex::scaleToExternal_`[protected]`

Scale from primal internal to external (in external order) Or other way for dual.

Definition at line 1137 of file AbcSimplex.hpp.

double* AbcSimplex::columnUseScale_`[protected]`

use this instead of columnScale

Definition at line 1139 of file AbcSimplex.hpp.

double* AbcSimplex::inverseColumnUseScale_`[protected]`

use this instead of inverseColumnScale

Definition at line 1141 of file AbcSimplex.hpp.

double* AbcSimplex::offset_`[protected]`

Primal offset (in external order) So internal value is (external-offset)*scaleFromExternal.

Definition at line 1145 of file AbcSimplex.hpp.

double* AbcSimplex::offsetRhs_`[protected]`

Offset for accumulated offsets*matrix.

Definition at line 1147 of file AbcSimplex.hpp.

double* AbcSimplex::tempArray_`[protected]`

Useful array of numberTotal length.

Definition at line 1149 of file AbcSimplex.hpp.

unsigned char* AbcSimplex::internalStatus_`[protected]`

Working status ? may be signed ? link pi_ to an indexed array? may have saved from last factorization at end.

Definition at line 1154 of file AbcSimplex.hpp.

unsigned char* AbcSimplex::internalStatusSaved_`[protected]`

Saved status.

Definition at line 1156 of file AbcSimplex.hpp.

double* AbcSimplex::abcPerturbation_`[protected]`

Perturbation (fixed) - is just scaled random numbers If perturbationFactor_<0 then virtual perturbation.

Definition at line 1159 of file AbcSimplex.hpp.

double* AbcSimplex::perturbationSaved_`[protected]`

saved perturbation

Definition at line 1161 of file AbcSimplex.hpp.

double* AbcSimplex::perturbationBasic_`[protected]`

basic perturbation

Definition at line 1163 of file AbcSimplex.hpp.

AbcMatrix* AbcSimplex::abcMatrix_`[protected]`

Working matrix.

Definition at line 1165 of file AbcSimplex.hpp.

double* AbcSimplex::abcLower_`[protected]`

Working scaled copy of lower bounds has original scaled copy at end.

Definition at line 1168 of file AbcSimplex.hpp.

double* AbcSimplex::abcUpper_`[protected]`

Working scaled copy of upper bounds has original scaled copy at end.

Definition at line 1171 of file AbcSimplex.hpp.

double* AbcSimplex::abcCost_`[protected]`

Working scaled copy of objective ? where perturbed copy or can we always work with perturbed copy (in B&B) if we adjust increments/cutoffs ? should we save a fixed perturbation offset array has original scaled copy at end.

Definition at line 1177 of file AbcSimplex.hpp.

double* AbcSimplex::abcSolution_`[protected]`

Working scaled primal solution may have saved from last factorization at end.

Definition at line 1180 of file AbcSimplex.hpp.

double* AbcSimplex::abcDj_`[protected]`

Working scaled dual solution may have saved from last factorization at end.

Definition at line 1183 of file AbcSimplex.hpp.

double* AbcSimplex::lowerSaved_`[protected]`

Saved scaled copy of lower bounds.

Definition at line 1185 of file AbcSimplex.hpp.

double* AbcSimplex::upperSaved_`[protected]`

Saved scaled copy of upper bounds.

Definition at line 1187 of file AbcSimplex.hpp.

double* AbcSimplex::costSaved_`[protected]`

Saved scaled copy of objective.

Definition at line 1189 of file AbcSimplex.hpp.

double* AbcSimplex::solutionSaved_`[protected]`

Saved scaled primal solution.

Definition at line 1191 of file AbcSimplex.hpp.

double* AbcSimplex::djSaved_`[protected]`

Saved scaled dual solution.

Definition at line 1193 of file AbcSimplex.hpp.

double* AbcSimplex::lowerBasic_`[protected]`

Working scaled copy of basic lower bounds.

Definition at line 1195 of file AbcSimplex.hpp.

double* AbcSimplex::upperBasic_`[protected]`

Working scaled copy of basic upper bounds.

Definition at line 1197 of file AbcSimplex.hpp.

double* AbcSimplex::costBasic_`[protected]`

Working scaled copy of basic objective.

Definition at line 1199 of file AbcSimplex.hpp.

double* AbcSimplex::solutionBasic_`[protected]`

Working scaled basic primal solution.

Definition at line 1201 of file AbcSimplex.hpp.

double* AbcSimplex::djBasic_`[protected]`

Working scaled basic dual solution (want it to be zero).

Definition at line 1203 of file AbcSimplex.hpp.

AbcDualRowPivot* AbcSimplex::abcDualRowPivot_`[protected]`

dual row pivot choice

Definition at line 1205 of file AbcSimplex.hpp.

AbcPrimalColumnPivot* AbcSimplex::abcPrimalColumnPivot_`[protected]`

primal column pivot choice

Definition at line 1207 of file AbcSimplex.hpp.

int* AbcSimplex::abcPivotVariable_`[protected]`

Basic variables pivoting on which rows followed by atLo/atUp then free/superbasic then fixed.

Definition at line 1211 of file AbcSimplex.hpp.

int* AbcSimplex::reversePivotVariable_`[protected]`

Reverse abcPivotVariable_ for moving around.

Definition at line 1213 of file AbcSimplex.hpp.

AbcSimplexFactorization* AbcSimplex::abcFactorization_`[protected]`

factorization

Definition at line 1215 of file AbcSimplex.hpp.

AbcSimplex* AbcSimplex::abcBaseModel_`[protected]`

Saved version of solution.

A copy of model with certain state - normally without cuts

Definition at line 1227 of file AbcSimplex.hpp.

ClpSimplex* AbcSimplex::clpModel_`[protected]`

A copy of model as ClpSimplex with certain state.

Definition at line 1229 of file AbcSimplex.hpp.

AbcNonLinearCost* AbcSimplex::abcNonLinearCost_`[protected]`

Very wasteful way of dealing with infeasibilities in primal.

However it will allow non-linearities and use of dual analysis. If it doesn't work it can easily be replaced.

Definition at line 1234 of file AbcSimplex.hpp.

CoinPartitionedVector AbcSimplex::usefulArray_[ABC_NUMBER_USEFUL]`[mutable, protected]`

Sum of nonbasic costs.

Definition at line 1240 of file AbcSimplex.hpp.

AbcSimplexProgress AbcSimplex::abcProgress_`[protected]`

For dealing with all issues of cycling etc.

Definition at line 1242 of file AbcSimplex.hpp.

ClpDataSave AbcSimplex::saveData_`[protected]`

For saving stuff at beginning.

Definition at line 1244 of file AbcSimplex.hpp.

double AbcSimplex::upperTheta_`[protected]`

upper theta from dual column

Definition at line 1246 of file AbcSimplex.hpp.

int AbcSimplex::multipleSequenceIn_[4]`[protected]`

Multiple sequence in.

Definition at line 1248 of file AbcSimplex.hpp.

int AbcSimplex::arrayForDualColumn_

Sum of nonbasic costs.

Definition at line 1250 of file AbcSimplex.hpp.

int AbcSimplex::arrayForReplaceColumn_

Sum of nonbasic costs.

Definition at line 1251 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFlipBounds_

Sum of nonbasic costs.

Definition at line 1252 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFlipRhs_

Sum of nonbasic costs.

Definition at line 1253 of file AbcSimplex.hpp.

int AbcSimplex::arrayForBtran_

Sum of nonbasic costs.

Definition at line 1254 of file AbcSimplex.hpp.

int AbcSimplex::arrayForFtran_

Sum of nonbasic costs.

Definition at line 1255 of file AbcSimplex.hpp.

int AbcSimplex::arrayForTableauRow_

Sum of nonbasic costs.

Definition at line 1256 of file AbcSimplex.hpp.

int AbcSimplex::numberFlipped_`[protected]`

Sum of nonbasic costs.

Definition at line 1258 of file AbcSimplex.hpp.

int AbcSimplex::numberDisasters_`[protected]`

Sum of nonbasic costs.

Definition at line 1259 of file AbcSimplex.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Alps-1.5.2/Clp/src/AbcSimplex.hpp